﻿@page "/"
@using DayZLegacy.Components
@using System.Diagnostics
@using System.IO
@using System.Runtime.InteropServices
@using DayZLegacy.Services
@using Shared
@implements IDisposable

<div class="d-flex flex-column h-100 col-2 position-absolute menu">
    <div class="d-flex flex-column mt-4">
        <img src="img/dayzz.png"/>
        <img src="img/legacy.png"/>
    </div>
    
    <div class="d-flex flex-column justify-content-center h-100 gap-20 align-items-sm-center">
        @if (PatchService.NeedsUpdate)
        {
            <Button ButtonText="Update"
                    HoverText="Update"
                    Disabled="@(!ConnectionService.IsConnected)"
                    OnClick="@HandleUpdateClickAsync" />
        }
        else
        {
            <Button ButtonText="Play"
                    HoverText="Run forest run"
                    Disabled="@(!ConnectionService.IsConnected)"
                    OnClick="@HandlePlayClick" />
        }
        
        <Button ButtonText="News" 
                HoverText="What's new" 
                Disabled="@(!ConnectionService.IsConnected)" 
                OnClick="@(() => NavigationManager.NavigateTo("/news"))" />
        
        <Button ButtonText="Settings" 
                HoverText="Crank that"
                OnClick="@(() => NavigationManager.NavigateTo("/settings"))" />
    </div>
</div>

<div class="position-absolute b-0 l-0 w-100">
    <div class="socials position-relative">
        <button class="raise" tabindex="-1" @onclick=@(() => GoToSocial("https://discord.gg/RwA9mYa4pR"))>
            <img src="img/discord.png"/>
        </button>
        <button class="raise" tabindex="-1" @onclick=@(() => GoToSocial("https://youtube.com/@doctorweed830"))>
            <img src="img/youtube.png"/>
        </button>
        <button class="raise" tabindex="-1" @onclick=@(() => GoToSocial("https://dayzlegacy.dev"))>
            <img src="img/dl.png"/>
        </button>
    </div>
    
    @if (!ConnectionService.IsConnected)
    {
        <div class="w-100 p-1 text-center bg-danger system-text font-size-14px">
            <span>No internet connection</span>
        </div>
    }
</div>

@code {
    
    [Inject] 
    private NavigationManager NavigationManager { get; set; } = default!;
    
    [Inject]
    private ConnectionService ConnectionService { get; set; } = default!;
    
    [Inject]
    private AlertService AlertService { get; set; } = default!;
    
    [Inject]
    private PatchService PatchService { get; set; } = default!;
    
    [Inject]
    private ConfigService ConfigService { get; set; } = default!;
    
    protected override void OnInitialized()
    {
        ConnectionService.OnConnectionChanged += ConnectionServiceOnConnectionChanged;
        PatchService.OnNeedsUpdate += StateHasChanged;
    }

    private void ConnectionServiceOnConnectionChanged()
    {
        InvokeAsync(StateHasChanged);
        if (ConnectionService.IsConnected)
        {
            PatchService.CheckForUpdateAsync().AndForget();
        }
    }

    public void Dispose()
    {
        ConnectionService.OnConnectionChanged -= ConnectionServiceOnConnectionChanged;
        PatchService.OnNeedsUpdate -= StateHasChanged;
    }
    
    private void GoToSocial(string url)
    {
        if (RuntimeInformation.IsOSPlatform(OSPlatform.Windows))
        {
            url = url.Replace("&", "^&");
            Process.Start(new ProcessStartInfo(url) { UseShellExecute = true });
        }
        else if (RuntimeInformation.IsOSPlatform(OSPlatform.Linux))
        {
            Process.Start("xdg-open", url);
        }
        else if (RuntimeInformation.IsOSPlatform(OSPlatform.OSX))
        {
            Process.Start("open", url);
        }
    }

    private void HandlePlayClick()
    {
        var pathResult = PatchService.HasValidExePath();
        if (pathResult.Error is not null)
        {
            AlertService.AddError(pathResult.Error.Message);
            return;
        }

        var gameResult = PatchService.StartGame();
        if (gameResult.Error is not null)
        {
            AlertService.AddError(gameResult.Error.Message);
        }
    }

    private async Task HandleUpdateClickAsync()
    {
        var result = await PatchService.PatchFilesAsync();
        if (result.Error is not null)
        {
            AlertService.AddError(result.Error.Message);
        }
    }
}